<?php
include 'crypto.php';
include 'sqlconn.php';

$ERROR_NO_ACCOUNT_FOUND = 104;
$ERROR_AUTH_FAILED = 103;

$inputContents = file_get_contents("php://input");
if(isset($inputContents)){
    $jsonObject = json_decode($inputContents, true);
    $phone = $jsonObject['emailOrPhone'];
    $password = $jsonObject['password'];
    
    // echo decryptValue(encryptValue("v", "k"), "kk");
     
    authUser($phone, $password);
}else{
    die("Invalid sign in request");
}

// echo filesize("php://input");
// echo json_decode(file_get_contents("php://input"), true)['k1'];

function authUser($emailOrPhone, $pass){
    if($emailOrPhone === null || $pass === null){
        die("Failed: Invalid sign in data");
    }
    
    $tableName = "USERS";
    
    $conn = createSqlConnection();
    
    $query = "SELECT * FROM $tableName WHERE phone = '$emailOrPhone'";
    $result = $conn->query($query);
    $userFound = $result->num_rows > 0;
    
    if($userFound === false){
        $queryByUser = "SELECT * FROM $tableName WHERE email = '$emailOrPhone'";

        $result = $conn->query($queryByUser);
        $userFound = $result->num_rows > 0;
    }

    if($userFound){
        
        $data = $result->fetch_assoc();
        
        $hashedPassword = hash('sha256', $pass);
        if($hashedPassword === $data['password']){
            echo json_encode(['success' => true, 'response' => json_encode($data)]);
        }else{
            echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_AUTH_FAILED'], 'response' => "Authentication failed"]);
        }
        
        
    }else{
        echo json_encode(['success' => false, 'errcode' => $GLOBALS['ERROR_NO_ACCOUNT_FOUND'], 'response' => "User not found"]);
    }
}


?>